/* dc_gui2 - a GTK+2 GUI for DCTC
 * Copyright (C) 2002 Eric Prevoteau
 *
 * str_array.h: Copyright (C) Eric Prevoteau <www@ac2i.tzo.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/*
$Id: str_array.h,v 1.2 2003/01/21 08:46:15 eric Exp $
*/

#ifndef __STR_ARRAY_H__
#define __STR_ARRAY_H__

/***********************************************/
/* add the given string inside the given array */
/***********************************************/
GPtrArray *str_array_del(GPtrArray *array, char *str);

/**************************************************/
/* remove the given string inside the given array */
/**************************************************/
GPtrArray *str_array_add(GPtrArray *array, char *str);

/*************************************************/
/* check if the given string is inside the array */
/*************************************************/
/* output: FALSE=no, TRUE=yes */
/******************************/
int str_array_is_inside(GPtrArray *array, char *str);

/********************************************************/
/* delete all entries of the array and the array itself */
/********************************************************/
void str_array_destroy(GPtrArray *array);

#endif
